package lieAlgebra;
/*
 * Licensed under the Creative Commons Zero (CC0) license (https://creativecommons.org/publicdomain/zero/1.0/)
 */

import pal.tree.Tree;
import pal.tree.TreeDistanceMatrix;

public class LMMTreeUtils {
	/**
	 * Returns the diameter of a tree - i.e. the longest leaf-to-leaf path.
	 * 
	 * Unsubtle O(n^2) implementation - I expect O(n log n) is possible.
	 * 
	 * @param tree
	 * @return
	 */
	public static double treeDiameter(Tree tree) {
		double[][] dists = new TreeDistanceMatrix(tree, tree, false, 0).getClonedDistances();
		int n=dists.length;
		double max = 0;
		for (int i=0; i<n; i++) {
			for (int j=0; j<n; j++) {
				max = Math.max(max, dists[i][j]);
			}
		}
		return max;
	}
}
